#!/usr/bin/perl 
# 
# bb-df-san-HP.pl 
# HP EVAs infos about disk group 
# nicolas figaro (pookicat at yahoo dot fr) 
# version : 1.0
# date : 10 may 2005
# version : 1.1
# date : 30 nov 2007
#
# should work on any unix based hobbit server
#
# requires : 
# perl 
# IPC::Open2 
# sssu 
# sudo (sssu is restricted to root) 
#

use strict; 
use IPC::Open2;
# put the names/ips of your bb displays, separated by commas  
my @BBDISPLAYS = ("10.10.10.10","10.10.10.11");

my $BBDISPLAY  ;
# requires sudo 
my $SSSU_CMD = "/usr/local/bin/sudo /usr/sbin/sssu"; 
# put the names/ips of your management appliances (manap), separated by commas  
my @MANAPS = ("manap1","manap2"); 
my ($MANAP,$ACTIVE_MANAP);
my $EVAS;
my $WARN_LEVEL=80; 
my $PANIC_LEVEL=90; 

my ($EVA,$DISK_GROUP_NAME,$CAPACITY,$OCCUPANCY,$FREE,$TOT_DISKS,$OPERATIONAL_STATE,$PERCENT,$DF_DETAILS); 

my $TEST="disk";

my ($COLOR,$REDLINE,$YELLOWLINE)=("green","",""); 

if ( ! $ENV{'BBTMP'} )
{ 	system (". $ENV{'BBHOME'}/etc/hobbitserver.cfg "); 
}

my ($SCRIPT,$EVA_LIST_BEGINS) ;
# grab the list of EVAs via sssu "show system" command
$SCRIPT = "select manager $MANAPS[0] username=administrator password=administrator\n"; 	
$SCRIPT = $SCRIPT . "show system\n"; 	
$SCRIPT = $SCRIPT . "exit\n"; 

# open2 allows you to run the command, send arguments and 
# get the results
#  open(FILE,"| cmd |"); 
my $SSSU_PID = open2(*Reader, *Writer, $SSSU_CMD);
print Writer $SCRIPT;
while (<Reader>)
{
	if (/^[Warning|Error]/)
  	{ 	die "Error with sssu : $_";
	}
	elsif (/Systems available/)
	{ 	$EVA_LIST_BEGINS=1; 
	}
	elsif (/\s+([\w\d\s-_]+)$/ and $EVA_LIST_BEGINS)
	{ 	
                if ( $EVAS ) 
		{ $EVAS = $EVAS.",$1"; 
		}
		else 
		{ $EVAS = $1;
		}
		chomp $EVAS; 
	}
}
close $SSSU_PID; 

# choose the first active MANAP
MANAP: foreach $MANAP (@MANAPS)
{ 
  $EVA = (split (",",$EVAS))[0];
  $SCRIPT = "select manager $MANAP username=administrator password=administrator\n"; 	
  $SCRIPT = $SCRIPT . "select system $EVA\n show disk_group full\n"; 
  $SCRIPT = $SCRIPT . "exit\n"; 

  my $SSSU_PID = open2(*Reader, *Writer, $SSSU_CMD);
  print Writer $SCRIPT;
  while (<Reader>)
  {  if (/Error: Storage System is managed by another agent/)
	{ $MANAP=""; 
	}
  }
  close $SSSU_PID; 
  $ACTIVE_MANAP=$MANAP;
  last MANAP if $ACTIVE_MANAP ; 
}

# get the list of disk groups for each EVA
foreach $EVA (split (",",$EVAS))
{ $SCRIPT = "select manager $ACTIVE_MANAP username=administrator password=administrator\n"; 	
  $SCRIPT = $SCRIPT . "select system $EVA\n show disk_group full\n"; 
  $SCRIPT = $SCRIPT . "exit\n"; 
# $DF_DETAILS = "\nDisk group	Total size(GB)	occupancy(GB)	Free size(GB)	% occupancy\n"; 
  $DF_DETAILS = "";
  # open2 once again
  my $SSSU_PID = open2(*Reader, *Writer, $SSSU_CMD);
  print Writer $SCRIPT;
  while (<Reader>)
  { 
           if (/^[Warning|Error]/)
  	{ die "error during sssu : $_";
	}
  # on recupere le nom de l'eva concern via le prompt affich en dbut de commande 
  # show lun, ceci permet de n'excuter qu'une fois le sssu. 
	if (/^(\w+EVA[\w\d]+)\>/)
	{ 	$EVA = $1 ; 
	}
   	elsif (/Name : \\Disk Groups\\([\w\d]+)/)
	{ 	$DISK_GROUP_NAME = $1;
		chomp $DISK_GROUP_NAME; 
		$DISK_GROUP_NAME = "\L$DISK_GROUP_NAME"; 
	}  
        elsif ( /Operational_state : ([\w\s\-]+)\s+/)
	{	$OPERATIONAL_STATE = $1; 
	}
        elsif ( /Total_capacity : ([\d]+)/)
	{	$CAPACITY = $1; 
	}
        elsif ( /Occupancy : ([\d]+)/)
	{	$OCCUPANCY = $1; 
		$FREE = $CAPACITY - $OCCUPANCY; 
		$PERCENT = int (100 * $OCCUPANCY / $CAPACITY); 

		if ( $PERCENT gt $PANIC_LEVEL ) 
		{ 	$COLOR = "red"; 
			$REDLINE = $REDLINE."$DISK_GROUP_NAME \($PERCENT\%) has reached the defined PANIC level ($PANIC_LEVEL\%)\n";  
		}
		elsif ( $PERCENT gt $WARN_LEVEL )
		{ 	$COLOR = "yellow" if "$COLOR" == "green" ; 
			$YELLOWLINE = $YELLOWLINE."$DISK_GROUP_NAME \($PERCENT\%) has reached the defined WARN level ($WARN_LEVEL\%)\n";  
		}
 		$DF_DETAILS = $DF_DETAILS."\/$DISK_GROUP_NAME  $CAPACITY  $OCCUPANCY  $FREE  $PERCENT\%  \/$DISK_GROUP_NAME\n"; 
	}
}
close $SSSU_PID; 

my $DATE=`date`; 
chomp $DATE;
my $LINE ; 
my $HOSTNAME = `hostname`; 
chomp $HOSTNAME; 
$HOSTNAME="$HOSTNAME.mgen.fij";
$EVA="\L$EVA"; 
if ( "$COLOR" eq "green" ) 
{ $LINE =  "status $EVA.$TEST $COLOR $DATE - SAN2 Disk groups OK\n\n$DF_DETAILS\n"; 
}
else 
{ $LINE =  "status $EVA.$TEST $COLOR $DATE - SAN2 Disk groups at $COLOR level $REDLINE$YELLOWLINE\n\n$DF_DETAILS\n"; 
}

foreach $BBDISPLAY (@BBDISPLAYS)
{
# should be done with bigbrother.pm module
system ("$ENV{'BBHOME'}/bin/bb $BBDISPLAY \"$LINE\"");
}
}
